.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgw::basegui 0.2" "" "" "" ""
.hy
.SS NAME
.RS
.PP
\f[B]dgw::basegui\f[R] \- starting point framework for writing Tk
applications
.RE
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
TYPE OPTIONS
.IP \[bu] 2
TYPE COMMANDS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INHERITANCE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require dgw::basegui
dgw::basegui cmdName
cmdName addStatusBar
cmdName autoscroll pathname
cmdName balloon pathname message
cmdName cballon canvasname tag message
cmdName center window
cmdName console ?pathname?
cmdName dlabel pathname
cmdName getFrame
cmdName getMenu
cmdName labentry pathname
cmdName message msg
cmdName notebook pathname
cmdName progress value
cmdName rotext pathname
cmdName splash imgfile ?\-delay milliseconds \-message textmessage?
cmdName status msg ?value?
cmdName subwidget widgetName
cmdName timer mode
cmdName treeview pathname
\f[R]
.fi
.SS DESCRIPTION
.PP
The \f[B]dgw::basegui\f[R] application framework serves as building
block for writing Tk applications.
It can be used for new applications as starting point providing useful
widgets such as a ready to use menubar, a mainframe and a statusbar etc
and various utility methods, for instance to add scrollbars, centering a
window on the screen.
It can be however as well added to existing applications as it provides
a few useful small widgets required in standard applications, such as a
tooltip/balloon, a sortable table widget (based on ttk::treeview), a
splash toplevel, a notebook with reorganizing facilities and popumenu
for renaming tabs, a labentry and so on.
Those widgets in many cases just add small functionalities with one or
two new methods or options to existing widgets, not worth to put them
into extra widget manual pages or even packages.
These widgets are therefore documented in this manual page.
.SS COMMAND
.PP
\f[B]dgw::basegui\f[R] \f[I]cmdName ?options?\f[R]
.RS
.PP
Creates and configures a new dgw::basegui application using the main Tk
window id \f[I].\f[R] and the given \f[I]options\f[R].
If the functionalties in this package should be added to existing
applications the option \f[I]\-start\f[R] should be set to
\f[I]false\f[R].
See the \f[I]start\f[R] option below for a more detailed explanation.
.RE
.SS TYPE OPTIONS
.PP
The \f[B]dgw::basegui\f[R] snit type supports the following options:
.PP
\f[B]\-start\f[R] \f[I]boolean\f[R]
.RS
.PP
Should the application in the toplevel be started automatically.
Default to \f[I]true\f[R].
In cases where you like to add just a few of the small widgets or
utility methods of the \f[I]dgw::basegui\f[R] package such as
\f[I]balloon\f[R], \f[I]notebook\f[R], \f[I]rotext\f[R],
\f[I]labentry\f[R] or some others to an existing application you should
set this as \f[I]false\f[R] at object creation.
.RE
.RS
.PP
The following methods can be used inside existing applications if the
option \f[I]\-start\f[R] was set to false:
.RE
.RS
.IP \[bu] 2
autoscroll
.IP \[bu] 2
balloon
.IP \[bu] 2
cballoon
.IP \[bu] 2
center
.IP \[bu] 2
console
.IP \[bu] 2
dlabel
.IP \[bu] 2
notebook
.IP \[bu] 2
rotext
.IP \[bu] 2
splash
.IP \[bu] 2
timer
.IP \[bu] 2
treeview
.RE
.PP
\f[B]\-style\f[R] \f[I]styleName\f[R]
.RS
.PP
Configures the ttk style for all widgets within the application.
`clam' and \[cq]default# should be supported on all platforms.
Use \f[C]ttk::style theme names\f[R] within an interactive wish session
to find out which themes are available on your machine.
.RE
.SS TYPE COMMANDS
.PP
Each \f[B]dgw::basegui\f[R] command supports the following public
methods to be used within inheriting applications to extend the basic
application.
Alternatively widgets can be added to existing applications as well.
.PP
\f[I]cmdName\f[R] \f[B]addStatusBar\f[R]
.RS
.PP
Packs and displays the statusbar widget at the bottom of the
application.
If not called the statusbar will be invisible.
.RE
.PP
\f[I]cmdName\f[R] \f[B]autoscroll\f[R] \f[I]pathname\f[R]
.RS
.PP
For the widget belonging to \f[I]pathname\f[R] add horizontal and
vertical scrollbars, shown only when needed.
Please note, that the widget in \f[I]pathname\f[R] must be the only
child of a \f[C]tk::frame\f[R] or a \f[C]ttk::frame\f[R] widget created
already.
The widget \f[I]pathname\f[R] is then managed by grid, don\[cq]t pack or
grid the widget in \f[I]pathname\f[R] yourself.
Handle it\[cq]s geometry via its parent frame.
See the following example:
.RE
.RS
.IP
.nf
\f[C]
package require dgw::basegui
::dgw::basegui app \-style clam
set f [app getFrame]
set tf [ttk::frame $f.tframe]
set t [text $tf.text \-wrap none]
app autoscroll $t
for {set i 0} {$i < 30} {incr i} {
$t insert end \[dq]Lorem ipsum dolor sit amet, ....\[rs]n\[rs]n\[dq]
}
pack $tf \-side top \-fill both \-expand yes
\f[R]
.fi
.RE
.PP
\f[I]cmdName\f[R] \f[B]balloon\f[R] \f[I]pathname message ?display?\f[R]
.RS
.PP
For the widget belonging to \f[I]pathname\f[R] displays for around three
seconds a small tooltip using the given \f[I]message\f[R].
The boolean variable \f[I]display\f[R] can be used to unregister the
tooltip at a later point.
See as well cballoon for tooltip on canvas tags.
.RE
.PP
\f[I]cmdName\f[R] \f[B]cballoon\f[R] \f[I]pathname tag message\f[R]
.RS
.PP
For the widget belonging to \f[I]pathname\f[R] display for the canvas
items labeled with \f[I]tag\f[R] the given message.
See as well balloon for standard tooltips for widgets.
.RE
.PP
\f[I]cmdName\f[R] \f[B]center\f[R] \f[I]window\f[R]
.RS
.PP
Centers a toplevel window on the screen.
.RE
.PP
\f[I]cmdName\f[R] \f[B]console\f[R] \f[I]?pathname?\f[R]
.RS
.PP
Displays a simple console in a toplevel if the target \f[I]pathname\f[R]
is not given, or within the application if the given \f[I]pathname\f[R]
is a valid widget path within an existing toplevel.
This console can be used to debug applications and to inspect variables,
commands etc.
Based on wiki code in A minimal
console (https://wiki.tcl-lang.org/page/A+minimal+console).
The \f[I]puts\f[R] commands entered within the \f[I]console\f[R] widget
are displayed within the widget.
.RE
.PP
\f[I]cmdName\f[R] \f[B]dlabel\f[R] \f[I]window\f[R]
.RS
.PP
Creates a ttk::label where the font size is dynamically adjusted to the
widget size.
Here an example:
.RE
.RS
.IP
.nf
\f[C]
dgw::basegui app \-start false
font create title \-family Helvetica \-size 10
toplevel .test
set txt \[dq] Some Title \[dq]
app dlabel .test.l \-text $txt \-font title
pack  .test.l \-expand 1 \-fill both
wm geometry .test 400x300+0+0
\f[R]
.fi
.RE
.PP
\f[I]cmdName\f[R] \f[B]getFrame\f[R]
.RS
.PP
Returns the mainframe of the application.
This function allows adding more widgets to the interior of the
application in inheriting applications or at a later point.
.RE
.PP
\f[I]cmdName\f[R] \f[B]getMenu\f[R] \f[I]menuName ?option value
\&...?\f[R]
.RS
.PP
Returns the menu entry belonging to the given \f[I]menuName\f[R] or
creates a new cascade with this \f[I]menuName\f[R] in the application
menubar.
This function allows adding more menu points in inheriting applications
or at a later point to the application.
At creation time or therafter additional configuration options can be
given such as \f[I]\-underline 0\f[R] for instance.
Here an example for inserting new menu points
.RE
.RS
.IP
.nf
\f[C]
::dgw::basegui app \-style clam
set fmenu [app getMenu \[dq]File\[dq]]
$fmenu insert 0 command \-label Open \-underline 0 \-command { puts Opening }
\f[R]
.fi
.RE
.PP
\f[I]cmdName\f[R] \f[B]labentry\f[R] \f[I]pathname ?\-option value
\&...?\f[R]
.RS
.PP
Creates a simple \f[I]labentry\f[R] widget where the main widget is the
entry widget.
The label is set with the \f[I]\-label\f[R] option.
All other options and methods are delegated to the entry widget.
The widget provides two additional methods:
.RE
.RS
.IP \[bu] 2
\f[I]pathname entry\f[R] to access directly the internal entry widget
.IP \[bu] 2
\f[I]pathname label\f[R] to access directly the internal label widget
.RE
.PP
\f[I]cmdName\f[R] \f[B]message\f[R] \f[I]msg\f[R]
.RS
.PP
Displays the text of \f[I]msg\f[R] in the statusbar.
Only useful if statusbar is displayed using the \f[I]addStatusBar\f[R]
command.
.RE
.PP
\f[I]cmdName\f[R] \f[B]notebook\f[R] \f[I]pathname ?\-option value?\f[R]
.RS
.PP
Creates a standard \f[I]ttk::notebook\f[R] with some additional
features, like right click popup for adding new tabs, rename existing
tabs and changing tab order.
There is further one additional option available:
.RE
.RS
.IP \[bu] 2
\f[I]\-createcmd command\f[R] invokes the given \f[I]command\f[R] if a
new page is created.
The \f[I]pathname\f[R] of the notebook and the page \f[I]index\f[R] are
added as arguments to the script call.
.RE
.RS
.PP
The widget further adds the following bindings to the standard
\f[I]ttk::notebook\f[R] widget:
.RE
.RS
.IP \[bu] 2
\f[I]F2\f[R] \- popup for moving and renaming tabs
.IP \[bu] 2
\f[I]Button\-3\f[R] \- popup for moving and renaming tabs
.IP \[bu] 2
\f[I]Ctrl\-Shift\-Left\f[R] \- move current tab to the left
.IP \[bu] 2
\f[I]Ctrl\-Shift\-Right\f[R] \- move current tab to the right
.IP \[bu] 2
\f[I]Ctrl\-w\f[R] \- close current tab
.IP \[bu] 2
\f[I]Ctrl\-t\f[R] \- create new tab
.RE
.PP
\f[I]cmdName\f[R] \f[B]progress\f[R] \f[I]value\f[R]
.RS
.PP
Displays the given \f[I]value\f[R] within the progressbar in the
statusbar widget.
Only useful if statusbar is displayed using the \f[I]addStatusBar\f[R]
command.
.RE
.PP
\f[I]cmdName\f[R] \f[B]rotext\f[R] \f[I]pathname\f[R] \f[I]?\-option
value \&...?\f[R]
.RS
.PP
Creates a readonly \f[I]text\f[R] widget.
All options are delegated to the standard textwidget, except for
\f[I]\-insertwidth\f[R].
The standard commands for the text widget work but not \f[I]insert\f[R]
and \f[I]delete\f[R].
They are replaced with the \f[I]ins\f[R] and \f[I]del\f[R] subcommands.
Useful fot displaying text to the user which should not be changed.
See the following example on how to handle inserts into the
\f[I]rotext\f[R] widget:
.RE
.RS
.IP
.nf
\f[C]
package require dgw::basegui
dgw::basegui app
# main application frame
set f [app getFrame]
# it is best to place it in a single frame if you need scrollbars
set roframe [ttk::frame $f.rf]
set rotext [app rotext $roframe.rotext \-background salmon]
app autoscroll $rotext
# scrollbar free rotext can be placed directly into the main frame
set rotext2 [app rotext $f.rotext \-autoscroll false]
for {set i 0} {$i < 100} {incr i 1} {
$rotext ins end \[dq]Sample text line $i\[rs]n\[dq]
$rotext2 ins end \[dq]Sample text line $i\[rs]n\[dq]
}
pack $roframe \-side top \-fill both \-expand true
pack $rotext2 \-side top \-fill both \-expand true
\f[R]
.fi
.RE
.PP
\f[I]cmdName\f[R] \f[B]splash\f[R] \f[I]imgfile ?\-delay milliseconds
\-message textmessage?\f[R]
.RS
.PP
Hides the main application and shows the given image in
\f[I]imgfile\f[R] as well as some textmessage given with the option
\-message.
The splash screen destroys itself after the given delay, default 2500.
If delay is given as zero (0), the splash widget is not destroyed.
If the \f[I]imgfile\f[R] variable is given as \f[C]update\f[R] then
additional messages can be given to the splash widget.
To destroy the splash method should be called with the imgfile argument
\f[C]destroy\f[R].
See below for an example.
The pathname of the splash toplevel is \f[C].splash\f[R].
.RE
.RS
.PP
Example with a simple single message splash:
.RE
.RS
.IP
.nf
\f[C]
app splash splash.png \-delay 2000 \-message \[dq]Loading editor application ...\[dq]
\f[R]
.fi
.RE
.RS
.PP
Example with multiple messages:
.RE
.RS
.IP
.nf
\f[C]
app splash splash.png \-delay 0 \-message \[dq]Loading editor application ...\[dq]
after 2000 { app splash update \-message \[dq]Loading data for editor application ...\[dq] }
after 4000 { app splash destroy }
\f[R]
.fi
.RE
.PP
\f[I]cmdName\f[R] \f[B]status\f[R] \f[I]msg ?value?\f[R]
.RS
.PP
Displays the text of \f[I]msg\f[R] as message and the optional value
within the progressbar in the statusbar widget.
Only useful if statusbar is displayed using the \f[I]addStatusBar\f[R]
command.
.RE
.PP
\f[I]cmdName\f[R] \f[B]subwidget\f[R] \f[I]widgetName\f[R]
.RS
.PP
Returns the widget belonging to the given \f[I]widgetName\f[R].
\f[I]widgetName\f[R] can be either \f[I]statusbar\f[R] or
\f[I]frame\f[R].
This function allows access to internal widgets at a later point.
.RE
.PP
\f[I]cmdName\f[R] \f[B]timer\f[R] \f[I]mode\f[R]
.RS
.PP
Simple timer procedure to measure execution time in the GUI.
The two modes are \f[I]reset\f[R] and \f[I]time\f[R], the first measured
time is initialized at \f[I]dgw::basegui\f[R] initialization:
.RE
.RS
.IP \[bu] 2
\f[I]reset\f[R] \- resets the time to the current time
.IP \[bu] 2
\f[I]time\f[R] \- gets the execution time after the last reset, this is
the default.
.RE
.RS
.IP
.nf
\f[C]
dgw::basegui app
puts \[dq]Startup in [app timer time] seconds!\[dq]
app timer reset
after 1500
puts \[dq]After time [app timer time] seconds!\[dq]
\f[R]
.fi
.RE
.PP
\f[I]cmdName\f[R] \f[B]treeview\f[R] \f[I]pathname ?\-option value
\&...?\f[R]
.RS
.PP
Creates a standard \f[I]ttk::treeview\f[R] widget with additional
sorting feature for the columns and banding stripes for the rows.
It has as well a \f[I]loadData\f[R] method to load nested lists.
See the following example.
.RE
.RS
.IP
.nf
\f[C]
dgw::basegui app
set f [app getFrame]
set tv [app treeview $f.tv]
set headers {country capital currency unit}
set data {
{Argentina          \[dq]Buenos Aires\[dq]          ARS 0.12}
{Australia          Canberra                AUD 0.11}
{Brazil             Brazilia                BRL 0.33}
{Canada             Ottawa                  CAD 0.56}
{China              Beijing                 CNY 0.88}
{France             Paris                   EUR 1.23}
{Germany            Berlin                  EUR 0.124}
{India              \[dq]New Delhi\[dq]             INR 0.12345}
{Italy              Rome                    EUR 1.2345}
}
pack $tv  \-side left \-expand yes \-fill both
$tv loadData $headers $data
\f[R]
.fi
.RE
.SS EXAMPLE
.PP
The following example demonstrates a few features for creating new
standalone applications using the faciltities of of the
\f[I]dgw::basegui\f[R] snit type.
The code can be executed directly using the \f[I]\[en]demo\f[R]
commandline switch.
.IP
.nf
\f[C]
::dgw::basegui app \-style clam
puts \[dq]Startup in [app timer time] seconds!\[dq]
app timer reset
after 1500
puts \[dq]After time [app timer time] seconds!\[dq]
set fmenu [app getMenu \[dq]File\[dq]]
$fmenu insert 0 command \-label Open \-underline 0 \-command { puts Opening }
app addStatusBar
set stb [app subwidget statusbar]
$stb progress 100
$stb set \[dq]starting ...\[dq]
after 100
app status progressing... 50
after 1000
app status finished 100
set f [app getFrame]
set btn [ttk::button $f.btn \-text \[dq]Hover me!\[dq]]
app balloon $btn \[dq]This is the hover message!\[rs]nNice ?\[dq]
pack $btn \-side top
set tf [ttk::frame $f.tframe]
set t [text $tf.text \-wrap none]
app autoscroll $t
for {set i 0} {$i < 30} {incr i} {
    $t insert end \[dq]Lorem ipsum dolor sit amet, consectetur adipiscing elit, 
  sed do eiusmod tempor 
     incididunt ut labore et dolore magna aliqua. 
   Ut enim ad minim veniam, quis nostrud exercitation 
     ullamco laboris nisi ut aliquip ex ea commodo consequat.\[rs]n\[rs]n\[dq]
}
pack $tf \-side top \-fill both \-expand yes
pack [canvas $f.c] \-side top \-fill both \-expand true
set id [$f.c create oval 10 10 110 110 \-fill red]
app cballoon $f.c $id \[dq]This is a red oval\[dq]
$f.c create rect 130 30 190 90 \-fill blue \-tag rect
app cballoon $f.c rect \[dq]This is\[rs]na blue square\[dq]
set nb [app notebook $f.nb]
set bframe [ttk::frame $nb.bf]
$nb add $bframe \-text \[dq]rotext\[dq]
set rotext [app rotext $bframe.rotext]
app autoscroll $rotext
for {set i 0} {$i < 50} {incr i 1} {
   $rotext ins end \[dq]Hello rotext ...\[rs]n\[dq]
}
set evar \[dq]entries text\[dq]
app labentry $nb.len \-label \[dq]The label\[dq] \-textvariable evar
$nb add $nb.len \-text \[dq]labentry\[dq]
pack $nb \-side top \-fill both \-expand true
\f[R]
.fi
.SS INHERITANCE
.PP
This snit type can be used to build up other more specialized
applications.
Here is an example, where we create a generic Editor class which adds
additional menu points and embeds a scrolled text widget.
.PP
The most basic inheritance example would be just copying the
functionality without the text widget.
.IP
.nf
\f[C]
package require dgw::basegui
snit::type EditorApp {
   component basegui
   # inheritance
   delegate method * to basegui
   delegate option * to basegui
   # variable addon to extend basegui
   variable textw
   constructor {args} {
        install basegui using dgw::basegui %AUTO%
        $self configurelist $args    
        # added functionality
        set f [$basegui getFrame]
        set textw [text $f.t \-wrap none]
        $self autoscroll $textw
   }
   # added functionality
   # access functionality of the text widget
   # like: % app text insert end \[dq]hello basegui world\[dq]
   method text {args} {
      $textw {*}$args
   }
}
if {[info exists argv0] && $argv0 eq [info script]} {
   #start editor
   EditorApp app
   app text insert end \[dq]Hello EditorApp!!\[dq]
}
\f[R]
.fi
.PP
This simple example should show how to extend the functionality of the
basegui toplevel.
Before you start to write specialized applications you should create a
simple proxy class which does nothing more than inheriting from
\f[C]dgw::basegui\f[R] first.
This is the code above without the text widget parts.
You can then extend this base class and your specialized applications
inherit from your baseclass.
This allows you to extend all your specialized classes using your
baseclass.
So your setup should be:
.IP
.nf
\f[C]

                                 \-\- your::editor
dgw::basegui \-\- your::basegui \-\-\-+
                                 \-\- your::databasebrowser

\f[R]
.fi
.PP
This is in the long term better than inheriting from
\f[C]dgw::basegui\f[R] directly.
You don\[cq]t like to change the code of this class, but you can change
\f[C]your::basegui\f[R] for instance to give better help facilities in
the Help menu, or other features you need in your applications most of
the time.
If you do this both application \f[C]your::editor\f[R] and
\f[C]your::databasebrowser\f[R] will have this functionality at the same
time after implementing it in \f[C]your::basegui\f[R] type.
If you follow this approach you can easily update the
\f[I]dgw::basegui\f[R] package without loosing your new functionalities.
.SS INSTALLATION
.PP
Installation is easy you can easily install and use this **
dgw::basegui** package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in
tcllib (https://core.tcl-lang.org/tcllib/doc/trunk/embedded/index.md)
.PP
For installation you copy the complete \f[I]dgw\f[R] folder into a path
of your \f[I]auto_path\f[R] list of Tcl or you append the
\f[I]auto_path\f[R] list with the parent dir of the \f[I]dgw\f[R]
directory.
Alternatively you can install the package as a Tcl module by creating a
file \f[C]dgw/basegui\-0.2.tm\f[R] in your Tcl module path.
The latter in many cases can be achieved by using the
\f[I]\[en]install\f[R] option of basegui.tcl.
Try \[lq]tclsh basegui.tcl \[en]install\[rq] for this purpose.
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ wish basegui.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ tclsh basegui.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh basegui.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag if the
Markdown library of tcllib is installed on your machine.
.IP
.nf
\f[C]
$ tclsh basegui.tcl \-\-html
\f[R]
.fi
.PP
This will directly create a HTML page \f[C]basegui.html\f[R] which
contains the formatted documentation.
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.IP
.nf
\f[C]
$ tclsh basegui.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to feed a markdown processor for
conversion into a html or pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
tclsh ../basegui.tcl \-\-man > basegui.md
pandoc \-i basegui.md \-s \-o basegui.html
pandoc \-i basegui.md \-s \-o basegui.tex
pdflatex basegui.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw \- package homepage:
https://chiselapp.com/user/dgroth/repository/tclcode/index (http://chiselapp.com/user/dgroth/repository/tclcode/index)
.SS TODOS
.IP \[bu] 2
socket check for starting the application twice
.IP \[bu] 2
tooltip embedded (done)
.IP \[bu] 2
auto scrolled command embedded for x and y scrollbars (done)
.SS AUTHOR
.PP
The \f[B]basegui\f[R] command was written by Detlef Groth, Schwielowsee,
Germany.
.SS COPYRIGHT
.PP
Copyright (c) 2019\-2020 Dr.\ Detlef Groth, E\-mail:
detlef(at)dgroth(dot)de
.SS LICENSE
.PP
dgw::basegui command, version 0.2.
.PP
Copyright (c) 2019\-2020 Dr.\ Detlef Groth, E\-mail:
detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
